;********************************;
; PARADOX Script: GetRpt         ;
;                                ;
; RptCheck, Version 1.1          ;
; 10 Jan 92                      ;
; Informant Communications Group ;
;                                ;
; Required scripts:              ;
;   GetRptCk                     ;
;   RptSet                       ;
;   GetRpt                       ;
;   LookUp                       ;
;********************************;

CREATELIB "GetRpt"

;*************************************************;
; GetRptName() is called when not in the Report   ;
; generator (i.e. Mode <> "Report").  It is used  ;
; to get the name of the Report for which changes ;
; are desired to be made.  RptNameScr() is called ;
; to display the data entry screen.               ;
;*************************************************;
PROC GetRptName()
  PRIVATE TempRpt,Key,Pos,Line,Item,Length

  Item=1

  RptNameScr()

  WHILE True
    ;
    ; define max length of field where line 1
    ; is for table name and line 3 report name
    ;
    IF Item=1
      THEN Length=8
           Line=1
      ELSE Length=2
           Line=3
    ENDIF

    Pos=Len(Names[Item])+1
    IF Pos=1
      THEN @5+Line,12+Pos ?? SPACES(Length)
    ENDIF
    CANVAS ON

    WHILE True
      @5+Line,12+Pos
      Key=GETCHAR()
      SWITCH
        CASE Key>48 AND Key<123:     ;printable char
          IF Pos>Length
            THEN BEEP
            ELSE Pos=Pos+1
                 ?? CHR(Key)
                 Names[Item]=Names[Item]+CHR(Key)
          ENDIF
          LOOP
        CASE Key=8 AND Pos>1:        ;Backspace
          Pos=Pos-1
          @5+Line,12+Pos ??" "
          IF Pos=1
            THEN Names[Item]=""
            ELSE Names[Item]=SUBSTR(Names[Item],1,Pos-1)
          ENDIF
          LOOP
        CASE Key = 127:              ;Ctrl Backspace
          Pos=1
          @5+Line,12+Pos ?? SPACES(Length)
          Names[Item]=""
          LOOP
        CASE Key = -72 AND Item=2:   ;Up
          Item=1
          QUITLOOP
        CASE Key = -80 AND Item=1:   ;Down
          Item=2
          QUITLOOP
        CASE Key = 13:               ;Enter
          ;
          ; check for blank fields and valid table
          ; and report names before proceeding
          ;
          IF ISBLANK(Names[Item])
            THEN BEEP
                 MESSAGE "Field cannot be left blank..."
                 SLEEP 500
                 QUITLOOP
          ENDIF
          IF Item=1
            THEN Item=2
                 QUITLOOP
          ENDIF
          IF NOT ISTABLE(Names[1])
            THEN BEEP
                 MESSAGE "Can't find Table "+Names[1]+"..."
                 SLEEP 1000
                 Names[1]=""
                 Item=1
                 RptNameScr()
                 QUITLOOP
          ENDIF
          IF UPPER(SUBSTR(Names[2],1,1))<>"R"
            THEN TempRpt="R"+Names[2]
            ELSE TempRpt=Names[2]
                 IF LEN(Names[2])>1
                   THEN Names[2]=SUBSTR(Names[2],2,1)
                 ENDIF
          ENDIF
          IF NOT ISFILE(Names[1]+"."+TempRpt)
            THEN BEEP
                 MESSAGE "Can't find Report "+Names[2]+
                         " for Table "+Names[1]+"..."
                 SLEEP 1000
                 Names[2]=""
                 Item=2
                 RptNameScr()
                 QUITLOOP
          ENDIF
          IF Item=2
            ;
            ; go to Modify Settings screen
            ;
            THEN ChangeRptSet()
                 CANVAS OFF
                 ECHO NORMAL
                 ECHO OFF
                 RptNameScr()
                 CANVAS ON
                 CURSOR NORMAL
                 QUITLOOP
          ENDIF
        CASE Key = 27:               ;Esc
          RETURN
        CASE Key = -59 AND Item=1:   ;F1
          ;
          ; display Table pick list
          ;
          LookUpTab()
          IF NOT ISBLANK(Names[2])
            THEN Item=2
          ENDIF
          CANVAS OFF
          ECHO NORMAL
          ECHO OFF
          RptNameScr()
          CANVAS ON
          CURSOR NORMAL
          QUITLOOP
        CASE Key = -59 AND Item=2:   ;F1
          ;
          ; display Report pick list
          ;
          GetRptDscpt(Names[1])
          CANVAS OFF
          ECHO NORMAL
          ECHO OFF
          RptNameScr()
          CANVAS ON
          CURSOR NORMAL
          QUITLOOP
        OTHERWISE:
          BEEP
      ENDSWITCH
    ENDWHILE
  ENDWHILE
ENDPROC


;***************************************************;
; RptNameScr() is called by GetRptName() to display ;
; the data entry screen for Report selection.       ;
;***************************************************;
PROC RptNameScr()
  CANVAS OFF
  ;
  ; paint shadow
  ;
  PAINTCANVAS
    ATTRIBUTE 8
    5,4,11,49

  STYLE ATTRIBUTE 48
  @4,3
  SETMARGIN 3

TEXT
REPORT SETTINGSĿ
                   Enter Table and Report   
  Table:           for which you desire to  
                   change settings.  Press  
 Report:           [F1] for list of current 
                   names or [Esc] to quit.  

ENDTEXT

  STYLE ATTRIBUTE 63
  ;
  ; display current selections
  ;
  @6,13 ?? Names[1]
  @8,13 ?? Names[2]

  SETMARGIN 0
ENDPROC


WRITELIB "GetRpt" GetRptName,RptNameScr
RELEASE PROCS GetRptName,RptNameScr

